#ifndef _B4325_FM_REGS_H
#define _B4325_FM_REGS_H


#define 	RDS_WATER_LEVEL			50

#define AUDIO_IOCTL_MAGIC 'a'

// ----------------------------------------------------------------------------
// Kernel driver interface
//
/* Source (TX) devices */
#define ADSP_AUDIO_DEVICE_ID_HANDSET_MIC	0x107ac8d
#define ADSP_AUDIO_DEVICE_ID_HEADSET_MIC	0x1081510
#define ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_MIC	0x1081512
#define ADSP_AUDIO_DEVICE_ID_BT_SCO_MIC		0x1081518
#define ADSP_AUDIO_DEVICE_ID_TTY_HEADSET_MIC	0x108151b
#define ADSP_AUDIO_DEVICE_ID_I2S_MIC		0x1089bf3
#define ADSP_AUDIO_DEVICE_ID_HANDSET_DUAL_MIC     0x108f9c3
#define ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_DUAL_MIC  0x108f9c5

/* Special loopback pseudo device to be paired with an RX device */
/* with usage ADSP_AUDIO_DEVICE_USAGE_MIXED_PCM_LOOPBACK */
#define ADSP_AUDIO_DEVICE_ID_MIXED_PCM_LOOPBACK_TX	0x1089bf2

/* Sink (RX) devices */
#define ADSP_AUDIO_DEVICE_ID_HANDSET_SPKR			0x107ac88
#define ADSP_AUDIO_DEVICE_ID_HEADSET_SPKR_MONO			0x1081511
#define ADSP_AUDIO_DEVICE_ID_HEADSET_SPKR_STEREO		0x107ac8a
#define ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_MONO			0x1081513
#define ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_MONO_W_MONO_HEADSET     0x108c508
#define ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_MONO_W_STEREO_HEADSET   0x108c894
#define ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_STEREO			0x1081514
#define ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_STEREO_W_MONO_HEADSET   0x108c895
#define ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_STEREO_W_STEREO_HEADSET	0x108c509
#define ADSP_AUDIO_DEVICE_ID_BT_SCO_SPKR			0x1081519
#define ADSP_AUDIO_DEVICE_ID_TTY_HEADSET_SPKR			0x108151c
#define ADSP_AUDIO_DEVICE_ID_I2S_SPKR				0x1089bf4

/* Qisda, Terry Cheng, Add for FM audio path {*/
#define ADSP_AUDIO_DEVICE_ID_NULL_SINK_FM_SPEAKER				0x208e512
#define ADSP_AUDIO_DEVICE_ID_NULL_SINK_FM_HEADSET				0x208e513
/* } Qisda, Terry Cheng, Add for FM audio path */

#define HANDSET_MIC                ADSP_AUDIO_DEVICE_ID_HANDSET_MIC
#define HANDSET_SPKR               ADSP_AUDIO_DEVICE_ID_HANDSET_SPKR
#define HEADSET_MIC                ADSP_AUDIO_DEVICE_ID_HEADSET_MIC
#define HEADSET_SPKR_MONO          ADSP_AUDIO_DEVICE_ID_HEADSET_SPKR_MONO
#define HEADSET_SPKR_STEREO        ADSP_AUDIO_DEVICE_ID_HEADSET_SPKR_STEREO
#define SPKR_PHONE_MIC             ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_MIC
#define SPKR_PHONE_MONO            ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_MONO
#define SPKR_PHONE_STEREO          ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_STEREO
//#define BT_A2DP_SPKR               ADSP_AUDIO_DEVICE_ID_BT_A2DP_SPKR
#define BT_SCO_MIC                 ADSP_AUDIO_DEVICE_ID_BT_SCO_MIC
#define BT_SCO_SPKR                ADSP_AUDIO_DEVICE_ID_BT_SCO_SPKR
#define TTY_HEADSET_MIC            ADSP_AUDIO_DEVICE_ID_TTY_HEADSET_MIC
#define TTY_HEADSET_SPKR           ADSP_AUDIO_DEVICE_ID_TTY_HEADSET_SPKR
#define FM_HEADSET                 ADSP_AUDIO_DEVICE_ID_NULL_SINK_FM_HEADSET
#define FM_SPKR	                   ADSP_AUDIO_DEVICE_ID_NULL_SINK_FM_SPEAKER
#define SPKR_PHONE_HEADSET_STEREO  ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_MONO_W_MONO_HEADSET
#define HANDSET_DUALMIC            ADSP_AUDIO_DEVICE_ID_HANDSET_DUAL_MIC
#define SPKR_DUALMIC               ADSP_AUDIO_DEVICE_ID_SPKR_PHONE_DUAL_MIC

#define I2S_RX				ADSP_AUDIO_DEVICE_ID_I2S_SPKR
#define I2S_TX				ADSP_AUDIO_DEVICE_ID_I2S_MIC

#define AUDIO_START _IOW(AUDIO_IOCTL_MAGIC, 0, unsigned)
#define AUDIO_STOP _IOW(AUDIO_IOCTL_MAGIC, 1, unsigned)
#define AUDIO_FLUSH _IOW(AUDIO_IOCTL_MAGIC, 2, unsigned)
#define AUDIO_GET_CONFIG _IOR(AUDIO_IOCTL_MAGIC, 3, unsigned)
#define AUDIO_SET_CONFIG _IOW(AUDIO_IOCTL_MAGIC, 4, unsigned)
#define AUDIO_GET_STATS _IOR(AUDIO_IOCTL_MAGIC, 5, unsigned)
#define AUDIO_ENABLE_AUDPP _IOW(AUDIO_IOCTL_MAGIC, 6, unsigned)
#define AUDIO_SET_ADRC _IOW(AUDIO_IOCTL_MAGIC, 7, unsigned)
#define AUDIO_SET_EQ _IOW(AUDIO_IOCTL_MAGIC, 8, unsigned)
#define AUDIO_SET_RX_IIR _IOW(AUDIO_IOCTL_MAGIC, 9, unsigned)
#define AUDIO_SET_VOLUME _IOW(AUDIO_IOCTL_MAGIC, 10, unsigned)
#define AUDIO_PAUSE _IOW(AUDIO_IOCTL_MAGIC, 11, unsigned)
#define AUDIO_PLAY_DTMF _IOW(AUDIO_IOCTL_MAGIC, 12, unsigned)
#define AUDIO_GET_EVENT _IOR(AUDIO_IOCTL_MAGIC, 13, unsigned)
#define AUDIO_ABORT_GET_EVENT _IOW(AUDIO_IOCTL_MAGIC, 14, unsigned)
#define AUDIO_REGISTER_PMEM _IOW(AUDIO_IOCTL_MAGIC, 15, unsigned)
#define AUDIO_DEREGISTER_PMEM _IOW(AUDIO_IOCTL_MAGIC, 16, unsigned)
#define AUDIO_ASYNC_WRITE _IOW(AUDIO_IOCTL_MAGIC, 17, unsigned)
#define AUDIO_ASYNC_READ _IOW(AUDIO_IOCTL_MAGIC, 18, unsigned)
#define AUDIO_SET_INCALL _IOW(AUDIO_IOCTL_MAGIC, 19, struct msm_voicerec_mode)
#define AUDIO_GET_NUM_SND_DEVICE _IOR(AUDIO_IOCTL_MAGIC, 20, unsigned)
#define AUDIO_GET_SND_DEVICES _IOWR(AUDIO_IOCTL_MAGIC, 21,   struct msm_snd_device_list)
#define AUDIO_ENABLE_SND_DEVICE _IOW(AUDIO_IOCTL_MAGIC, 22, unsigned)
#define AUDIO_DISABLE_SND_DEVICE _IOW(AUDIO_IOCTL_MAGIC, 23, unsigned)
#define AUDIO_ROUTE_STREAM _IOW(AUDIO_IOCTL_MAGIC, 24,   struct msm_audio_route_config)
#define AUDIO_GET_PCM_CONFIG _IOR(AUDIO_IOCTL_MAGIC, 30, unsigned)
#define AUDIO_SET_PCM_CONFIG _IOW(AUDIO_IOCTL_MAGIC, 31, unsigned)
#define AUDIO_SWITCH_DEVICE _IOW(AUDIO_IOCTL_MAGIC, 32, unsigned)
#define AUDIO_SET_MUTE _IOW(AUDIO_IOCTL_MAGIC, 33, unsigned)
#define AUDIO_UPDATE_ACDB _IOW(AUDIO_IOCTL_MAGIC, 34, unsigned)
#define AUDIO_START_VOICE _IOW(AUDIO_IOCTL_MAGIC, 35, unsigned)
#define AUDIO_STOP_VOICE _IOW(AUDIO_IOCTL_MAGIC, 36, unsigned)
#define AUDIO_REINIT_ACDB _IOW(AUDIO_IOCTL_MAGIC, 39, unsigned)

#define AUDIO_SET_STREAM_CONFIG _IOW(AUDIO_IOCTL_MAGIC, 80,   struct msm_audio_stream_config)
#define AUDIO_GET_STREAM_CONFIG _IOR(AUDIO_IOCTL_MAGIC, 81,   struct msm_audio_stream_config)
#define AUDIO_GET_SESSION_ID _IOR(AUDIO_IOCTL_MAGIC, 82, unsigned short)
#define AUDIO_GET_STREAM_INFO _IOR(AUDIO_IOCTL_MAGIC, 83,   struct msm_audio_bitstream_info)
#define AUDIO_SET_PAN _IOW(AUDIO_IOCTL_MAGIC, 84, unsigned)
#define AUDIO_SET_QCONCERT_PLUS _IOW(AUDIO_IOCTL_MAGIC, 85, unsigned)
#define AUDIO_SET_MBADRC _IOW(AUDIO_IOCTL_MAGIC, 86, unsigned)
#define AUDIO_SET_VOLUME_PATH _IOW(AUDIO_IOCTL_MAGIC, 87,   struct msm_vol_info)
#define AUDIO_SET_MAX_VOL_ALL _IOW(AUDIO_IOCTL_MAGIC, 88, unsigned)
#define AUDIO_ENABLE_AUDPRE _IOW(AUDIO_IOCTL_MAGIC, 89, unsigned)
#define AUDIO_SET_AGC _IOW(AUDIO_IOCTL_MAGIC, 90, unsigned)
#define AUDIO_SET_NS _IOW(AUDIO_IOCTL_MAGIC, 91, unsigned)
#define AUDIO_SET_TX_IIR _IOW(AUDIO_IOCTL_MAGIC, 92, unsigned)




#define I2C_FM_RDS_SYSTEM      		0x00
#define I2C_FM_CTRL            		0x01
#define I2C_RDS_CTRL0	      		0x02
#define I2C_RDS_CTRL1      		0x03
#define I2C_FM_AUDIO_PAUSE      	0x04
#define I2C_FM_AUDIO_CTRL0      	0x05
#define I2C_FM_AUDIO_CTRL1	      	0x06
#define I2C_FM_SEARCH_CTRL0      	0x07
#define I2C_FM_SEARCH_CTRL1      	0x08
#define I2C_FM_SEARCH_TUNE_MODE      	0x09
#define I2C_FM_FREQ0      		0x0a
#define I2C_FM_FREQ1      		0x0b
#define I2C_FM_AF_FREQ0      		0x0c
#define I2C_FM_AF_FREQ1      		0x0d
#define I2C_FM_CARRIER      		0x0e
#define I2C_FM_RSSI      		0x0f
#define I2C_FM_RDS_MASK0      		0x10
#define I2C_FM_RDS_MASK1      		0x11
#define I2C_FM_RDS_FLAG0      		0x12
#define I2C_FM_RDS_FLAG1      		0x13
#define I2C_RDS_WLINE      		0x14
#define I2C_RDS_BLKB_MATCH0      	0x16
#define I2C_RDS_BLKB_MATCH1      	0x17
#define I2C_RDS_BLKB_MASK0      	0x18
#define I2C_RDS_BLKB_MASK1      	0x19
#define I2C_RDS_PI_MATCH0      		0x1a
#define I2C_RDS_PI_MATCH1      		0x1b
#define I2C_RDS_PI_MASK0      		0x1c
#define I2C_RDS_PI_MASK1      		0x1d
#define I2C_FM_RDS_BOOT      		0x1e
#define I2C_FM_RDS_TEST      		0x1f
#define I2C_SPARE0      		0x20
#define I2C_SPARE1      		0x21
#define I2C_FM_RDS_REV_ID      		0x28
#define I2C_SLAVE_CONFIGURATION      	0x29
#define I2C_FM_PCM_ROUTE      		0x4d
#define I2C_RDS_DATA      		0x80
#define I2C_FM_BEST_TUNE      		0x90
#define I2C_FM_SEARCH_METHOD      	0xfc
#define I2C_FM_SEARCH_STEPS      	0xfd
#define I2C_FM_MAX_PRESET      		0xfe
#define I2C_FM_PRESET_STATION      	0xff

enum  {
    BCOMFM_RDS_MODE,
    BCOMFM_RBDS_MODE
};

enum
{
    BCOMFM_BAND_EUUS,
    BCOMFM_BAND_JP
};

enum
{
    BCOMFM_MUTE_DISABLED,
    BCOMFM_MUTE_ENABLED
};


enum
{
    BCOMFM_SCAN_DIR_UP,
    BCOMFM_SCAN_DIR_DOWN
};

enum
{
    BCOMFM_POWER_OFF,
    BCOMFM_POWER_ON
};

enum
{
    BCOMFM_RDS_POWER_OFF,
    BCOMFM_RDS_POWER_ON
};

// BCOMFM Power
#define BCOMFM_POWER_PWF         (1 << 0)
#define BCOMFM_POWER_PWR         (1 << 1)

//BCOM FM_CTRL
//stereo/mono auto select
#define BCOMFM_AUTO_SELECT_STEREO_MONO		(1<<1)
#define BCOMFM_MANUAL_SELECT__STEREO_MONO	(0<<1)
#define BCOMFM_MANUAL_SET_STEREO				(1<<2)
//#define BCOMFM_MANUAL_SET_MONO				(0<<2)
#define BCOMFM_STEREO_MONO_BLEND			(0<<3)
#define BCOMFM_STEREO_MONO_SWITCH			(1<<3)

//BCOM FM_AUDIO_PAUSE
//RSSI
#define BCOMFM_AUDIO_PAUSE_RSSI_21DB		(0<<0)
#define BCOMFM_AUDIO_PAUSE_RSSI_18DB		(1<<0)
#define BCOMFM_AUDIO_PAUSE_RSSI_15DB		(2<<0)
#define BCOMFM_AUDIO_PAUSE_RSSI_12DB		(3<<0)
//duration
#define BCOMFM_AUDIO_PAUSE_RSSI_20MS		(0<<4)
#define BCOMFM_AUDIO_PAUSE_RSSI_26MS		(1<<4)
#define BCOMFM_AUDIO_PAUSE_RSSI_33MS		(2<<4)
#define BCOMFM_AUDIO_PAUSE_RSSI_40MS		(3<<4)

//BCOM FM_AUDIO_CTRL0
#define BCOMFM_ENABLE_RF_MUTE		(1<<0)
//#define BCOMFM_DISABLE_RF_MUTE		(0<<0)
#define BCOMFM_MANUAL_MUTE_ON		(1<<1)
//#define BCOMFM_MANUAL_MUTE_OFF		(0<<1)
#define BCOMFM_DAC_OUTPUT_LEFT		(1<<2)
#define BCOMFM_DAC_OUTPUT_RIGHT		(1<<3)
#define BCOMFM_AUDIO_ROUTE_DAC		(1<<4)
#define BCOMFM_AUDIO_ROUTE_I2S		(1<<5)
#define BCOMFM_DE_EMPHASIS_75		(1<<6)


//BCOM FM_SERACH_CTRL0
#define BCOMFM_SERACH_UP				(1<<7)
//#define BCOMFM_SERACH_DOWN			(0<<7)

//BCOM FM_SEARCH_TUNE_MODE
#define BCOMFM_STOP_TUNE				(0<<0)
#define BCOMFM_PRE_SET					(1<<0)
#define BCOMFM_AUTO_SERCH				(2<<0)
#define BCOMFM_AF_JUMP					(3<<0)

//BCOM FM_RDS_FLAG
//Byte 1 0x12
#define BCOMFM_FLAG_SEARCH_TUNE_DONE	(1<<0)
#define BCOMFM_FLAG_SEARCH_FAIL			(1<<1)
#define BCOMFM_FLAG_RSSI_LOW				(1<<2)
#define BCOMFM_FLAG_CARRIER_ERROR_HIGH	(1<<3)
#define BCOMFM_FLAG_AUDIO_PAUSE_IND		(1<<4)
#define BCOMFM_FLAG_STEREO_DETECTED		(1<<5)
#define BCOMFM_FLAG_STEREO_ACTIVE		(1<<6)
//Byte 2 0x13
#define BCOMFM_FLAG_RDS_FIFO_WLINE		(1<<1)
#define BCOMFM_FLAG_RDS_B_BLOCK_MATCH	(1<<3)
#define BCOMFM_FLAG_RDS_SYNC_LOST		(1<<4)
#define BCOMFM_FLAG_RDS_PI_MATCH			(1<<5)

#define BAND_EUUS_START_FREQ  	880
#define BAND_EUUS_END_FREQ  	1080
   

#endif






